#include <SPI.h>
#include <RFID.h>
#include <Practicum.h>

#include "usbdrv.h"

#define RQ_GET_RFID 3

#define SS_PIN PIN_PB2
#define RST_PIN PIN_PB1

RFID rfid(SS_PIN, RST_PIN);

//////////////////////////////////////////////////////////////////////
usbMsgLen_t usbFunctionSetup(uint8_t data[8])
{
  usbRequest_t *rq = (usbRequest_t*)data;
	static uint8_t ID_RFID;

  if (rq->bRequest == RQ_GET_RFID)
	{
			if (rfid.isCard()) {
				if (rfid.readCardSerial()) {
					ID_RFID = rfid.serNum[1];
   			}
			}else {
					ID_RFID = 0; 
			}
			usbMsgPtr = (uint8_t*) &ID_RFID;
			return sizeof(ID_RFID);
	}

  return 0;   /* nothing to do; return no data back to host */
}

//////////////////////////////////////////////////////////////////////
void setup()
{
		SPI.begin();
		rfid.init();		
    usbInit();
	  /* enforce re-enumeration of USB devices */
    usbDeviceDisconnect();
    delay(300);
    usbDeviceConnect();
}

//////////////////////////////////////////////////////////////////////
void loop()
{
  usbPoll();
}
